#!/usr/local/bin/tsipp
#
# Ellipsoid object. -misc = POINT_FAR, POINT_NEAR, DIRECTION, TWO_LIGHTS,
#                           NARROW_SHARP, WIDE_SHARP, NARROW_SOFT
#
# $Id: ellipsoid.tcl,v 1.2 1996/05/26 20:19:37 markd Exp $
#

source ../utils.tcl

ParseArgs

switch -- [string toupper $misc] {
    POINT_FAR {
        SippLightSourceCreate {30.0 30.0 30.0} {0.9 0.9 0.9} POINT
    }
    POINT_NEAR {
        SippLightSourceCreate {3.0 3.0 3.0} {0.9 0.9 0.9} POINT
    }
    DIRECTION {
        SippLightSourceCreate {1.0 1.0 1.0} {0.9 0.9 0.9} DIRECTION
    }
    TWO_LIGHTS {
        SippLightSourceCreate {10.0 10.0 10.0} {0.9 0.9 0.9} POINT
        SippLightSourceCreate {-10.0 10.0 10.0} {0.9 0.9 0.9} POINT
    }
    NARROW_SHARP {
        SippSpotLightCreate {10.0 10.0 10.0} {0 0 0} D7 {0.9 0.9 0.9} SHARP
        SippLightSourceCreate {-1.0 1.0 1.0} {0.3 0.3 0.3} DIRECTION
    }
    WIDE_SHARP {
        SippSpotLightCreate {10.0 10.0 10.0} {0 0 0} D12 {0.9 0.9 0.9} SHARP
        SippLightSourceCreate {-1.0 1.0 1.0} {0.4 0.4 0.4} DIRECTION
    }
    NARROW_SOFT {
        SippSpotLightCreate {10.0 10.0 10.0} {0 0 0} D7 {0.9 0.9 0.9} SOFT
        SippLightSourceCreate {-1.0 1.0 1.0} {0.4 0.4 0.4} DIRECTION
    }
    default {Fatal "Invalid value for -misc \"$misc\""}
}

set shader [SippShaderBasic 0.2 0.6 0.2 {0.0 0.0 1.0}]
set obj [SippEllipsoid {2.0 3.0 2.0} 32 $shader]
SippObjectAddSubobj WORLD $obj


SippCameraParams STDCAMERA {0.0 0.0 10.0} {0.0 0.0 0.0} {0.0 1.0 0.0} 0.4
SippShowBackFaces $backfaces

set pbm [SippPBMOpen $output w]
SippRender $pbm $size $size $mode [expr $final ? 3 : 1]
SippPBMClose $pbm
